#!/usr/bin/env python

"""**********************************************************************
  DLMS/COSEM components

  i-cube, 1376 Goumoens-la-Ville, Switzerland
          infos@icube.ch

 (C)Copyright 2004-2012
**********************************************************************

"""


class HDLCProtocol(object):
    """Implementation of the HDLC protocol."""
    

    def __init__(self, hdlcParameters, IOStream):
        """Creates an instance of HDLCProtocol class.
            @param hdlcParameters: HDLC parameters to use.
            @param IOStream: IOStream to send/receive data to/from the meter
                any object which provides the following methods:
            def read(self, size=1):
                Read size bytes from the stream. A timeout mechanism should be implemented.
                If a timeout is set it may return less characters as requested.
            def write(self, data):
                Output the given string over the stream.
                
            @raise exception: EzHdlcException - raised for any detected error
        """
        pass
    
    def connect(self):
        """Connects the HDLC channel to the server.
            @raise EzHdlcException: Raised for any detected error.
        """
        pass
    
    def disconnect(self):
        """Disconnects the HDLC channel from the server.
            @raise EzHdlcException: Raised for any detected error.
        """
        pass
                
    def send_receive(self, outData):
        """Sends bytes to the server and then receives bytes from the server.
            @param outData: byte[] Byte stream to be send to the server.
            @return: type:MemoryStream Received bytes.
            @raise EzHdlcException: Raised for any detected error.
        """
        pass
